﻿@model List<ContactInfoViewModel>
@using System.Security.Claims
@{
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var area = role == Roles.FirmPrincipal ? "firm-principal" : role == Roles.FirmAdmin ? "firm-admin" : "adviser";
}
<form action="adviser/profile/savecontactinfo" class="form fv-plugins-bootstrap fv-plugins-framework" id="kt_contactinfo_form" method="post" data-ajax="true" data-ajax-begin="onFormBegin" data-ajax-complete="onFormCompleteWithWizard">
    <div class="d-flex justify-content-between">
        <div>
            <h4 class="text-dark font-weight-bold mt-2 mb-5 mr-5">Keep us updated with your personal contact information</h4>
        </div>
        <div>
            <button class="btn btn-secondary font-weight-bold px-6 py-2" id="btn-save-exit">Save & Exit</button>
        </div>
    </div>
    <div class="wizard-content-height" id="main-div">
        @foreach (var item in Model.Select((value, i) => new { i, value }))
        {
            <div class="contact-info-div">
                <input type="hidden" asp-for="@Model[item.i].AddressType">
                <input type="hidden" asp-for="@Model[item.i].Id">
                <input type="hidden" asp-for="@Model[item.i].Guid">
                <div id="AddressDiv_@item.i" class="addres-container">
                    <div class="d-flex mb-3">
                        @if (item.value.AddressType == AddressTypeEnum.Resident || (item.value.AddressType == AddressTypeEnum.Business && item.i == 1))
                        {
                            <div class="align-self-center">
                                <h3 class="text-primary mr-5 mb-0">@item.value.AddressType.ToString() Contact Info</h3>
                            </div>
                        }
                        @if (item.value.AddressType == AddressTypeEnum.Business)
                        {
                            if (item.i == 1)
                            {
                                <div class="align-self-center">
                                    <button class="btn btn-primary font-weight-bold font-size-h6 btn-sm btn-address-add" type="button"><i class="fas fa-plus"></i> New Address</button>
                                </div>
                            }
                        }
                    </div>
                    @if (item.value.AddressType == AddressTypeEnum.Business)
                    {
                        <div class="d-flex mb-2">
                            <div>
                                <span class="btn btn-light-primary btn-hover-light-primary label-inline font-size-h6 font-weight-bold px-3 py-1">Address @item.i</span>
                            </div>
                            @if (item.i != 1)
                            {
                                <div class="ml-auto align-self-center">
                                    <button type="button" class="btn btn-sm btn-icon btn-outline-danger btn-hover-light-danger btn-circle btn-delete-contact" data-toggle="tooltip" title="Delete" data-guid="@item.value.Guid">
                                        <i class="fas fa-trash"></i>
                                    </button>
                                </div>
                            }
                        </div>
                    }
                    <div class="row">
                        <div class="col-xl-5">
                            <div class="form-group">
                                <label asp-for="@Model[item.i].Address"></label>
                                <input asp-for="@Model[item.i].Address" class="form-control form-control-lg capitalize">
                                <span asp-validation-for="@Model[item.i].Address" class="text-danger"></span>
                            </div>
                        </div>
                        <div class="col-xl-5">
                            <div class="form-group">
                                <label asp-for="@Model[item.i].Address2"></label>
                                <input asp-for="@Model[item.i].Address2" class="form-control form-control-lg capitalize">
                            </div>
                        </div>
                        <div class="col-xl-2">
                            <div class="form-group">
                                <label asp-for="@Model[item.i].POBox"></label>
                                <input asp-for="@Model[item.i].POBox" class="form-control form-control-lg">
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xl-4">
                            <div class="form-group">
                                <label asp-for="@Model[item.i].ZipCode"></label>
                                <input asp-for="@Model[item.i].ZipCode" class="form-control form-control-lg zipcode" data-type="Address_@item.i">
                                <span asp-validation-for="@Model[item.i].ZipCode" class="text-danger"></span>
                            </div>
                        </div>
                        <div class="col-xl-4 address d-none">
                            <div class="form-group">
                                <label asp-for="@Model[item.i].State"></label>
                                <input asp-for="@Model[item.i].State" id="Address_@(item.i)_State" class="form-control form-control-lg">
                                <span asp-validation-for="@Model[item.i].State" class="text-danger"></span>
                            </div>
                        </div>
                        <div class="col-xl-4 address d-none">
                            <div class="form-group">
                                <label asp-for="@Model[item.i].City"></label>
                                <input asp-for="@Model[item.i].City" id="Address_@(item.i)_City" class="form-control form-control-lg">
                                <span asp-validation-for="@Model[item.i].City" class="text-danger"></span>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xl-4">
                            <div class="form-group">
                                <label asp-for="@Model[item.i].Phone"></label>
                                <input asp-for="@Model[item.i].Phone" id="Address_@(item.i)_Phone" class="form-control form-control-lg phone" data-target="Address_@(item.i)_CellNumber">
                                <span asp-validation-for="@Model[item.i].Phone" class="text-danger"></span>
                            </div>
                        </div>
                        <div class="col-xl-4">
                            <div class="form-group">
                                <label asp-for="@Model[item.i].CellNumber"></label>
                                <input asp-for="@Model[item.i].CellNumber" id="Address_@(item.i)_CellNumber" class="form-control form-control-lg phone" data-target="Address_@(item.i)_Phone">
                                <span asp-validation-for="@Model[item.i].CellNumber" class="text-danger"></span>
                            </div>
                        </div>
                    </div>
                </div>
                @if (item.value.AddressType == AddressTypeEnum.Resident)
                {
                    <hr />
                }
            </div>
        }
    </div>
    <partial name="_WizardFooter" />
</form>
<script id="address-template" type="text/html">
     <div class="contact-info-div">
         <div id="AddressDiv_${i}" class="addres-container">
         <div class="d-flex mb-2">
            <div>
                <span class="btn btn-light-primary btn-hover-light-primary label-inline font-size-h6 font-weight-bold px-3 py-1">Address ${i}</span>
            </div>
            <div class="ml-auto align-self-center">
                <button type="button" class="btn btn-sm btn-icon btn-outline-danger btn-hover-light-danger btn-circle btn-remove-contact" data-toggle="tooltip" title="Remove" >
                    <i class="fas fa-times"></i>
                </button>
            </div>
         </div>
         <input type="hidden" id="z${i}__AddressType" name="[${i}].AddressType" value="Business">
         <div class="row">
        <div class="col-xl-5">
            <div class="form-group">
                <label for="z${i}__Address">Street Address</label>
                <input class="form-control form-control-lg capitalize" type="text" data-val="true" data-val-maxlength="The field Street Address must be a string or array type with a maximum length of '30'." data-val-maxlength-max="30" data-val-required="Provide Street Address" id="z${i}__Address" maxlength="30" name="[${i}].Address" placeholder="Street Address" data-lpignore="true" autocomplete="new-password" aria-describedby="z${i}__Address-error" aria-invalid="false">
                <span class="text-danger field-validation-valid" data-valmsg-for="[${i}].Address" data-valmsg-replace="true"></span>
            </div>
        </div>
        <div class="col-xl-5">
            <div class="form-group">
                <label for="z${i}__Address2">Suite/Apt #</label>
                <input class="form-control form-control-lg capitalize" type="text" data-val="true" data-val-maxlength="The field Suite/Apt # must be a string or array type with a maximum length of '30'." data-val-maxlength-max="30" id="z${i}__Address2" maxlength="30" name="[${i}].Address2" placeholder="Suite/Apt #" data-lpignore="true" autocomplete="new-password" aria-describedby="z${i}__Address2-error" aria-invalid="false">
            </div>
        </div>
        <div class="col-xl-2">
            <div class="form-group">
                <label for="z${i}__POBox">P.O. Box</label>
                <input class="form-control form-control-lg" type="text" id="z${i}__POBox" name="[${i}].POBox" placeholder="P.O. Box" data-lpignore="true" maxlength="20" autocomplete="new-password" aria-describedby="z${i}__POBox-error" aria-invalid="false">
            </div>
        </div>
    </div>
         <div class="row">
        <div class="col-xl-4">
            <div class="form-group">
                <label for="z${i}__ZipCode">Zip Code</label>
                <input class="form-control form-control-lg zipcode" data-type="Address_${i}" type="text" data-val="true" data-val-required="Provide Zip Code" id="z${i}__ZipCode" name="[${i}].ZipCode" placeholder="Zip Code" data-lpignore="true" im-insert="true" maxlength="20" autocomplete="new-password" aria-describedby="z${i}__ZipCode-error" aria-invalid="false">
                <span class="text-danger" data-valmsg-for="[${i}].ZipCode" data-valmsg-replace="true"></span>
            </div>
        </div>
        <div class="col-xl-4 address">
            <div class="form-group">
                <label for="z${i}__State">State</label>
                <input id="Address_${i}_State" class="form-control form-control-lg" type="text" data-val="true" data-val-required="Provide State" name="[${i}].State" placeholder="State" data-lpignore="true" maxlength="20">
                <span class="text-danger" data-valmsg-for="[${i}].State" data-valmsg-replace="true"></span>
            </div>
        </div>
        <div class="col-xl-4 address">
            <div class="form-group">
                <label for="z${i}__City">City</label>
                <input id="Address_${i}_City" class="form-control form-control-lg" type="text" data-val="true" data-val-required="Provide City" name="[${i}].City" placeholder="City" data-lpignore="true" maxlength="20">
                <span class="text-danger" data-valmsg-for="[${i}].City" data-valmsg-replace="true"></span>
            </div>
        </div>
    </div>
         <div class="row">
        <div class="col-xl-4">
            <div class="form-group">
                <label for="z${i}__Phone">Phone</label>
                <input id="Address_${i}_Phone" class="form-control form-control-lg phone" data-target="Address_${i}_CellNumber" type="text" data-val="true" data-val-required="Provide Phone" name="[${i}].Phone" placeholder="(___) ___-____" data-lpignore="true" im-insert="true" maxlength="20" autocomplete="new-password">
                <span class="text-danger" data-valmsg-for="[${i}].Phone" data-valmsg-replace="true"></span>
            </div>
        </div>
        <div class="col-xl-4">
            <div class="form-group">
                <label for="z${i}__CellNumber">Mobile/Cell Phone</label>
                <input id="Address_${i}_CellNumber" class="form-control form-control-lg phone" data-target="Address_${i}_Phone" type="text" data-val="true" data-val-required="Provide Mobile/Cell Phone" name="[${i}].CellNumber" placeholder="Cell Phone" data-lpignore="true" im-insert="true" maxlength="20" autocomplete="new-password" aria-describedby="Address_${i}_CellNumber-error" aria-invalid="false">
                <span class="text-danger" data-valmsg-for="[${i}].CellNumber" data-valmsg-replace="true"></span>
            </div>
        </div>
    </div>
    </div>
     </div>
</script>
<script>
    var lastindex = 0;
    var validatePhone = function() {
        $(".phone").each(function(i, item) {
            var target = $(item).attr("data-target");
            if ($(item).val()) {
                $(`#${target}`).rules("remove");
                $(`#${target}`).removeClass("input-validation-error").addClass("valid").empty();
                $(`#${target}`).siblings(".field-validation-error").removeClass("field-validation-error").empty();
            }
            else
                $(`#${target}`).rules('add', 'required');
        })
    }
    setTimeout(function() { validatePhone(); }, 0);
    var showHideZip = function(el, zipcode, type) {
        zipcode = zipcode ? zipcode.replace(/_/g, '') : zipcode;
        $(el).find(".address").addClass("d-none");
        if (zipcode && zipcode.length > 4) {
            $(el).find(".address").removeClass("d-none");
            $(`#${type}_State`).val("");
            $(`#${type}_City`).val("");
            $.get(`https://zip.getziptastic.com/v2/US/${zipcode}`, function(response) {
                $(`#${type}_State`).val(response.state);
                $(`#${type}_City`).val(response.city);
            });
        }
        else
            $(el).find(".address").addClass("d-none");
    }
    $("[id^='AddressDiv_']").each(function() {
        var zipcode = $(this).find(".zipcode").val();
        var type = $(this).attr("id");
        showHideZip($(this), zipcode, type);
        lastindex = $(this).attr("id").replace("AddressDiv_", "");
    });
    $(document).on("input", ".zipcode", function() {
        var zipcode = $(this).val();
        var type = $(this).attr("data-type");
        var el = $(this).closest(".addres-container");
        showHideZip(el, zipcode, type);
    });
    $(document).on("input", ".phone", function() {
        validatePhone();
    });
    $(".btn-address-add").on('click', function(e) {
        if (lastindex < 2) {
            if ($("#kt_contactinfo_form").valid()) {
                lastindex++;
                var data = { i: lastindex };
                $("#main-div").append($("#address-template").tmpl(data));
                $(".zipcode").inputmask({ "mask": "99999" });
                $(".phone").inputmask({ "mask": "(999) 999-9999" });
                $("form").removeData("validator");
                $("form").removeData("unobtrusiveValidation");
                $.validator.unobtrusive.parse("form");
                validatePhone();
            }
            $(`#z${lastindex}__Address`).focus();
        }
        else
            _showFormMessage(`kt_contactinfo_form`, "warning", "You can't add more than 2 Business Contacts", "fas fa-exclamation-triangle")
    });
    $(document).on("click", ".btn-delete-contact", function(e) {
        e.preventDefault();
        var cur = this;
        var swalOptions = confimationSwalOptions;
        Swal.fire(swalOptions).then(function(result) {
            if (result.value) {
                var guid = $(cur).attr("data-guid");
                deleteRecord(`adviser/profile/deletecontactinfo?guid=${guid}`, function(response) {
                    if (response.success) {
                        KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
                        setTimeout(function() { KTApp.unblockPage(); }, 1000);
                        $(cur).closest(".contact-info-div").remove();
                        loadPartialView(`adviser/profile/contactinfo`, "wizard-content-div", "wizard-main-div");
                    }
                    else
                        Swal.fire("Cancelled", response.message, "error");
                });
            }
        });
    });
    $(document).on("click", ".btn-remove-contact", function(e) {
        lastindex--;
        e.preventDefault();
        $(this).closest(".contact-info-div").remove();
    });
</script>